<form [formGroup]="productForm" #f="ngForm" (ngSubmit)="onSubmit(f.value)">
  <mat-form-field appearance="standard">
    <mat-label>Title</mat-label>
    <input
      matInput
      placeholder="title"
      [(ngModel)]="product.title"
      formControlName="title"
    />
    <mat-error *ngIf="productForm.get('title').hasError('required')">
      Title is <strong>required</strong>
    </mat-error>
  </mat-form-field>
  <mat-form-field appearance="standard">
    <mat-label>Price</mat-label>
    <input
      matInput
      type="number"
      class="example-right-align"
      [(ngModel)]="product.price"
      formControlName="price"
    />
    <span matPrefix>$&nbsp;</span>
    <span matSuffix></span>
    <mat-error *ngIf="productForm.get('price').hasError('required')">
      Price is <strong>required</strong>
    </mat-error>
    <mat-error *ngIf="productForm.get('price').hasError('min')">
      Price should be <strong>0 or higher</strong>
    </mat-error>
  </mat-form-field>
  <mat-form-field appearance="standard">
    <mat-label>Category</mat-label>
    <mat-select [(ngModel)]="product.category" formControlName="category">
      <mat-option></mat-option>
      <mat-option *ngFor="let c of categories$ | async" [value]="c.key">
        {{ c.name }}
      </mat-option>
    </mat-select>
    <mat-error *ngIf="productForm.get('category').hasError('required')">
      Category is <strong>required</strong>
    </mat-error>
  </mat-form-field>
  <mat-form-field appearance="standard">
    <mat-label>Image URL</mat-label>
    <input
      matInput
      placeholder="image URL"
      [(ngModel)]="product.imageUrl"
      formControlName="imageUrl"
    />
    <mat-error *ngIf="productForm.get('imageUrl').hasError('required')">
      Image URL is <strong>required</strong>
    </mat-error>
    <mat-error *ngIf="productForm.get('imageUrl').hasError('url')">
      Please enter a <strong>valid URL</strong>
    </mat-error>
  </mat-form-field>
  <div class="button">
    <button type="submit" class="save-button" mat-raised-button color="primary">
      Save
    </button>
    <button
      (click)="delete()"
      type="button"
      class="delete-button"
      mat-raised-button
      color="warn"
    >
      Delete
    </button>
  </div>
</form>
